__author__ = 'tomlun'

import pyglet

import scene
import mainmenuscene


class GameMenuScene(scene.Scene):

    _continue = None
    _exit = None

    _background_color = None
    _background = None
    _batch = None
    _active_index = 0

    _bg_color_active = (100, 100, 100, 200)
    _bg_color_default = (0, 0, 0, 0)

    def build(self):
        self._batch = pyglet.graphics.Batch()

        self._background_color = pyglet.sprite.Sprite(
            pyglet.image.SolidColorImagePattern(color=(0, 0, 0, 150)).create_image(
                self._scene_manager.get_window_width(), self._scene_manager.get_window_height()
            ),
            x=0, y=0, batch=self._batch,
            group=pyglet.graphics.OrderedGroup(0)
        )

        self._background = pyglet.sprite.Sprite(
            pyglet.resource.texture('mainmenuscene.png'),
            x=self._scene_manager.get_window_width() / 2 - 160,
            y=self._scene_manager.get_window_height() / 2 - 240,
            batch=self._batch,
            group=pyglet.graphics.OrderedGroup(1)
        )

        self._continue = pyglet.text.Label(
            ' Continue ',
            font_name='wendy',
            font_size=16,
            x=self._scene_manager.get_window_width() / 2,
            y=self._scene_manager.get_window_height() / 2,
            anchor_x='center', anchor_y='center',
            batch=self._batch,
            group=pyglet.graphics.OrderedGroup(2)
        )
        self._continue.set_style('background_color', self._bg_color_active)

        self._exit = pyglet.text.Label(
            ' Return to main menu ',
            font_name='wendy',
            font_size=16,
            x=self._scene_manager.get_window_width() / 2,
            y=self._scene_manager.get_window_height() / 2 - 32,
            anchor_x='center', anchor_y='center',
            batch=self._batch,
            group=pyglet.graphics.OrderedGroup(2)
        )

    def draw(self):
        self._batch.draw()

    def on_key_release(self, symbol, modifiers):
        if symbol == pyglet.window.key.ENTER:
            if self._active_index == 0:
                self._scene_manager.pop_scene()
            if self._active_index == 1:
                self._scene_manager.pop_scene()
                self._scene_manager.pop_scene()
                self._scene_manager.push_scene(mainmenuscene.MainMenuScene(self._scene_manager))

        if symbol == pyglet.window.key.UP:
            self._active_index -= 1
            if self._active_index < 0:
                self._active_index = 0

            if self._active_index == 0:
                self._continue.set_style('background_color', self._bg_color_active)
                self._exit.set_style('background_color', self._bg_color_default)

        if symbol == pyglet.window.key.DOWN:
            self._active_index += 1
            if self._active_index > 1:
                self._active_index = 1

            if self._active_index == 1:
                self._continue.set_style('background_color', self._bg_color_default)
                self._exit.set_style('background_color', self._bg_color_active)