__author__ = 'tomlun'

import pyglet

import scene
import mainmenuscene


class GameMenuScene(scene.Scene):

    _title = None
    _instruction = None
    _background = None
    _batch = None

    def build(self):
        self._batch = pyglet.graphics.Batch()

        self._background = pyglet.sprite.Sprite(
            pyglet.image.SolidColorImagePattern(color=(0, 0, 0, 150)).create_image(
                self._scene_manager.get_window_width(), self._scene_manager.get_window_height()
            ),
            x=0, y=0, batch=self._batch,
            group=pyglet.graphics.OrderedGroup(0)
        )

        self._title = pyglet.text.Label(
            'Game over',
            font_name='wendy',
            font_size=28,
            x=self._scene_manager.get_window_width() / 2,
            y=self._scene_manager.get_window_height() / 2,
            anchor_x='center', anchor_y='center',
            batch=self._batch,
            group=pyglet.graphics.OrderedGroup(1)
        )

        self._instruction = pyglet.text.Label(
            'Press [Enter] to return to main menu',
            font_name='wendy',
            font_size=16,
            x=self._scene_manager.get_window_width() / 2,
            y=self._scene_manager.get_window_height() / 2 - 24,
            anchor_x='center', anchor_y='center',
            batch=self._batch,
            group=pyglet.graphics.OrderedGroup(1)
        )

    def draw(self):
        self._batch.draw()

    def on_key_release(self, symbol, modifiers):
        if symbol == pyglet.window.key.ENTER:
            self._scene_manager.pop_scene()
            self._scene_manager.pop_scene()
            self._scene_manager.push_scene(mainmenuscene.MainMenuScene(self._scene_manager))