__author__ = 'tomlun'

import pyglet
from pyglet.gl import *

# setup resource path
pyglet.resource.path = ['data', 'data/levels']
pyglet.resource.reindex()

import scene
import mainmenuscene


class Window(pyglet.window.Window):

    def __init__(self, width, height):
        pyglet.window.Window.__init__(self, width, height, caption='Hacker Intrusion')

        self.set_mouse_visible(False)

        glEnable(GL_BLEND)
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)

        # register the update and draw events
        self.register_event_type('update')
        self.register_event_type('draw')

        # schedule the update method
        pyglet.clock.schedule_interval(self.on_update, 1.0 / 60.0)

    def on_update(self, dt):
        self.dispatch_event('update', dt)

    def on_draw(self):
        self.clear()
        self.dispatch_event('draw')

    def on_key_press(self, symbol, modifiers):
        if symbol == pyglet.window.key.ESCAPE:
            return pyglet.event.EVENT_HANDLED  # make sure we don't close the window on escape


def run():
    # create our window
    window = Window(800, 600)

    # load the custom font
    pyglet.resource.add_font('wendy.ttf')

    # create a scene manager
    scene_manager = scene.SceneManager(window)
    scene_manager.push_scene(mainmenuscene.MainMenuScene(scene_manager))

    # run the app
    pyglet.app.run()