__author__ = 'tomlun'

import pyglet

from tiles import TILE_SIZE

_TERMINAL = 0
_DOOR1 = 1
_DOOR2 = 2


def create_object(object_type, x, y, batch):
    if object_type == _TERMINAL:
        return Terminal(x * TILE_SIZE, y * TILE_SIZE, batch)
    if object_type == _DOOR1:
        return Door1(x * TILE_SIZE, y * TILE_SIZE, batch)
    if object_type == _DOOR2:
        return Door2(x * TILE_SIZE, y * TILE_SIZE, batch)


class Object(pyglet.sprite.Sprite):

    _image = None

    def __init__(self, x, y, batch):
        pyglet.sprite.Sprite.__init__(self, self._image, x, y, batch=batch)
        self.center_x = x + TILE_SIZE / 2
        self.center_y = y + TILE_SIZE / 2


class InteractableObject(Object):
    pass


class Terminal(InteractableObject):
    _image = pyglet.resource.texture('terminal.png')


class Door1(InteractableObject):
    _image = pyglet.resource.texture('door1.png')


class Door2(InteractableObject):
    _image = pyglet.resource.texture('door1.png')