__author__ = 'tomlun'

import random
import pyglet

import scene
import mainmenuscene


class TerminalScene(scene.Scene):

    _background = None
    _terminal = None
    _console = None
    _console_tick = 0
    _batch = None
    _done = False

    def build(self):
        self._batch = pyglet.graphics.Batch()

        self._background = pyglet.sprite.Sprite(
            pyglet.image.SolidColorImagePattern(color=(0, 0, 0, 150)).create_image(
                self._scene_manager.get_window_width(), self._scene_manager.get_window_height()
            ),
            x=0, y=0, batch=self._batch,
            group=pyglet.graphics.OrderedGroup(0)
        )

        self._terminal = pyglet.sprite.Sprite(
            pyglet.resource.image('terminalscene.png'),
            x=self._scene_manager.get_window_width() / 2 - 320,
            y=self._scene_manager.get_window_height() / 2 - 240,
            batch=self._batch,
            group=pyglet.graphics.OrderedGroup(1)
        )

        self._console = pyglet.text.Label(
            '> run bsec\n',
            font_name='wendy',
            font_size=14,
            x=self._scene_manager.get_window_width() / 2 - 260,
            y=self._scene_manager.get_window_height() / 2 - 245,
            width=320,
            height=430,
            anchor_x='left', anchor_y='bottom',
            multiline=True, batch=self._batch
        )

        pyglet.clock.schedule_once(self.output_console, 0.5)

    def output_console(self, dt):
        # really ugly but hey
        if self._console_tick < 6:
            self._console.text += '. '
        elif self._console_tick == 6:
            self._console.text += '\n------ Bypass Security v2.43 ------\n'
        elif 6 < self._console_tick < 200:
            self._console.text += '{0} '.format(random.randint(0, 1))
            self._console_tick += 1
            pyglet.clock.schedule_once(self.output_console, 0.01)
            return
        else:
            self._console.text += '\nData extracted\nPress [Enter] to quit'
            self._done = True
            return

        self._console_tick += 1
        pyglet.clock.schedule_once(self.output_console, 0.5)

    def draw(self):
        self._batch.draw()

    def on_key_release(self, symbol, modifiers):
        if symbol == pyglet.window.key.ENTER and self._done:
            self._scene_manager.pop_scene()
            self._scene_manager.pop_scene()
            self._scene_manager.push_scene(mainmenuscene.MainMenuScene(self._scene_manager))